//************************************************************
//*  Visual C Sample. Allows to show PWL Resources.          *
//*  (C)1998 by Vitaly Evseenko, E-Mail: kapitan@thearmy.com *
//************************************************************

#include <windows.h>

typedef struct tagPSWDCACHE {
	WORD wEntLen;		// size of this entry, in bytes
	WORD wResLen;		// size of resource name, in bytes
	WORD wPswLen;		// size of password, in bytes
	BYTE Number;		// entry Number 
	BYTE EnType;		// type of entry
	BYTE Resource[1];	// start of resource
} PSWDCACHE;

char szOutStr[0xF000];
char OutBuf[512];
char TmpBuf[512];

LPSTR lpst = szOutStr;

WORD (__stdcall *WNECPAddr)(LPSTR, WORD, BYTE, void*, DWORD);

BOOL CALLBACK CacheProc(PSWDCACHE *CacheEntr, DWORD dwx) {

	memmove(TmpBuf, CacheEntr->Resource, CacheEntr->wResLen);
	TmpBuf[CacheEntr->wResLen] = 0;
	CharToOem(TmpBuf, OutBuf);
	lpst += wsprintf(lpst, "%-30s : ",  OutBuf);

	memmove(TmpBuf, CacheEntr->Resource+CacheEntr->wResLen, CacheEntr->wPswLen);
	TmpBuf[CacheEntr->wPswLen] = 0;
	CharToOem(TmpBuf, OutBuf);
	lpst += wsprintf(lpst, "%s\n", OutBuf);

	return TRUE;
}


int APIENTRY WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                        LPSTR lpszCmdLine, int nCmdShow )
{

	HINSTANCE hInst = LoadLibrary("MPR.DLL");

	if(!hInst){
		MessageBox(0,"Couldn't load MPR.DLL", 0, MB_ICONSTOP);
		return (-1);
	}

	WNECPAddr = (WORD (__stdcall *)(LPSTR, WORD, BYTE, void*, DWORD))
		GetProcAddress(hInst, "WNetEnumCachedPasswords");

	if(!WNECPAddr) {
		MessageBox(0, "Couldn't import the function \"WNetEnumCachedPasswords\"",
			0, MB_ICONSTOP);
		return(-1);
	}

	(*WNECPAddr)(0,0, 0xff, CacheProc, 0);
	FreeLibrary(hInst);

	MessageBox(0, szOutStr,"PWL Show -|- c0DED bY MadMat", MB_ICONINFORMATION);
}
